diff --git a/lib/librte_ethdev/ethdev_driver.h b/lib/librte_ethdev/ethdev_driver.h
index 06ff35266f..7b0f392e34 100644
--- a/lib/librte_ethdev/ethdev_driver.h
+++ b/lib/librte_ethdev/ethdev_driver.h
@@ -289,6 +289,10 @@ typedef int (*eth_fw_version_get_t)(struct rte_eth_dev *dev,
 				     char *fw_version, size_t fw_size);
 /**< @internal Get firmware information of an Ethernet device. */
 
+typedef int (*eth_representor_info_get_t)(struct rte_eth_dev *dev,
+	struct rte_eth_representor_info *info);
+/**< @internal Get representor type and ID range. */
+
 typedef int (*eth_tx_done_cleanup_t)(void *txq, uint32_t free_cnt);
 /**< @internal Force mbufs to be from TX ring. */
 
@@ -940,6 +944,9 @@ struct eth_dev_ops {
 
 	eth_get_monitor_addr_t get_monitor_addr;
 	/**< Get power monitoring condition for Rx queue. */
+
+	eth_representor_info_get_t representor_info_get;
+	/**< Get representor info. */
 };
 
 /**
diff --git a/lib/librte_ethdev/rte_ethdev.c b/lib/librte_ethdev/rte_ethdev.c
index 60889a8663..c88e345e7d 100644
--- a/lib/librte_ethdev/rte_ethdev.c
+++ b/lib/librte_ethdev/rte_ethdev.c
@@ -3265,6 +3265,20 @@ rte_eth_dev_fw_version_get(uint16_t port_id, char *fw_version, size_t fw_size)
 							fw_version, fw_size));
 }
 
+int
+rte_eth_representor_info_get(uint16_t port_id,
+			     struct rte_eth_representor_info *info)
+{
+	struct rte_eth_dev *dev;
+
+	RTE_ETH_VALID_PORTID_OR_ERR_RET(port_id, -ENODEV);
+	dev = &rte_eth_devices[port_id];
+
+	RTE_FUNC_PTR_OR_ERR_RET(*dev->dev_ops->representor_info_get, -ENOTSUP);
+	return eth_err(port_id, (*dev->dev_ops->representor_info_get)(dev,
+								      info));
+}
+
 int
 rte_eth_dev_info_get(uint16_t port_id, struct rte_eth_dev_info *dev_info)
 {
diff --git a/lib/librte_ethdev/rte_ethdev.h b/lib/librte_ethdev/rte_ethdev.h
index 9cd519bf59..a72843c65c 100644
--- a/lib/librte_ethdev/rte_ethdev.h
+++ b/lib/librte_ethdev/rte_ethdev.h
@@ -1581,6 +1581,38 @@ struct rte_eth_dev_info {
 	void *reserved_ptrs[2];   /**< Reserved for future fields */
 };
 
+/**
+ * @warning
+ * @b EXPERIMENTAL: this structure may change without prior notice.
+ *
+ * ethernet device representor ID range entry
+ */
+struct rte_eth_representor_range {
+	enum rte_eth_representor_type type; /**< Representor type */
+	int controller; /**< Controller ID, -1 to ignore */
+	int pf; /**< Physical function ID, -1 to ignore */
+	__extension__
+	union {
+		int vf; /**< VF start index */
+		int sf; /**< SF start index */
+	};
+	uint16_t id_base; /**< Representor ID start index */
+	uint16_t id_end;  /**< Representor ID end index */
+	char name[RTE_DEV_NAME_MAX_LEN]; /**< Representor name */
+};
+
+/**
+ * @warning
+ * @b EXPERIMENTAL: this structure may change without prior notice.
+ *
+ * Ethernet device representor information
+ */
+struct rte_eth_representor_info {
+	uint16_t controller; /**< Controller ID of caller device. */
+	uint16_t pf; /**< Physical function ID of caller device. */
+	struct rte_eth_representor_range ranges[];/**< Representor ID range. */
+};
+
 /**
  * Ethernet device RX queue information structure.
  * Used to retrieve information about configured queue.
@@ -3038,6 +3070,25 @@ int rte_eth_macaddr_get(uint16_t port_id, struct rte_ether_addr *mac_addr);
  */
 int rte_eth_dev_info_get(uint16_t port_id, struct rte_eth_dev_info *dev_info);
 
+/**
+ * Retrieve the representor info of the device.
+ *
+ * @param port_id
+ *   The port identifier of the device.
+ * @param info
+ *   A pointer to a representor info structure.
+ *   NULL to return number of range entries and allocate memory
+ *   for next call to store detail.
+ * @return
+ *   - (-ENOTSUP) if operation is not supported.
+ *   - (-ENODEV) if *port_id* invalid.
+ *   - (-EIO) if device is removed.
+ *   - (>=0) number of representor range entries supported by device.
+ */
+__rte_experimental
+int rte_eth_representor_info_get(uint16_t port_id,
+				 struct rte_eth_representor_info *info);
+
 /**
  * Retrieve the firmware version of a device.
  *
diff --git a/lib/librte_ethdev/version.map b/lib/librte_ethdev/version.map
index a124e1e370..bb6f7436c2 100644
--- a/lib/librte_ethdev/version.map
+++ b/lib/librte_ethdev/version.map
@@ -243,6 +243,9 @@ EXPERIMENTAL {
 
 	# added in 21.02
 	rte_eth_get_monitor_addr;
+
+	# added in 21.05
+	rte_eth_representor_info_get;
 };
 
 INTERNAL {